package org.fmi.ejb;

import java.lang.reflect.Method;
import java.util.Hashtable;

import javax.ejb.EJBException;
import javax.naming.Context;
import javax.naming.Name;
import javax.naming.Reference;
import javax.naming.StringRefAddr;
import javax.naming.spi.ObjectFactory;

public class EJBObjectFactory implements ObjectFactory,IIOPRemoteObjectFactory  {
	
	public ClientView getClientView(Reference ref) {
		if (ref == null) {
			return null;
		}
		
		StringRefAddr beanNameAddr = (StringRefAddr)ref.get("ejb-link");
		
		EJB ejb = EJBContainerFactory.getEJBContainer().getEJB(
				(String)beanNameAddr.getContent());
		
		StringRefAddr remoteAddr = (StringRefAddr)ref.get("remote");
		StringRefAddr localAddr = (StringRefAddr)ref.get("local");
		
		String intf = null;
		if (remoteAddr != null ) {
			intf = (String)remoteAddr.getContent();
		} else if (localAddr != null ) {
			intf = (String)localAddr.getContent();
		}
		
		if (intf != null ) {
			Class clazz;
			try {
				clazz = ejb.getClassLoader().loadClass(intf);
			} catch (ClassNotFoundException e) {
				throw new EJBException(e);
			}
			InvocationChain chain = ejb.getChainsManager().getChains(clazz).getChain(null);
			try {
				return (ClientView)ejb.getChainsManager().startChain(chain,(ClientView)null,
						(InstanceID)null,
						(Method)null,
						(Object[])null);
			} catch(ApplicationException ex) {
				if (ex.getCause() instanceof Exception) {
					throw new EJBException((Exception)ex.getCause());
				} else {
					throw new EJBException(new RuntimeException(ex.getCause()));
				}
			}
		} else {
			return null;
		}
		
	}		


	public Object getObjectInstance(Object obj, Name name, Context nameCtx, Hashtable<?, ?> environment) throws Exception {
		return getClientView((Reference)obj);
	}	
	
}
