package org.fmi.ejb;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

public class RemoteInvocationHandlerAdapter implements InvocationHandler {

	private RemoteInvocationHandler rih;
	private String beanName;
	private Class[] intfs;
	
	public RemoteInvocationHandlerAdapter(
			RemoteInvocationHandler rih,
			String beanName,
			Class[] intfs) {
		this.rih = rih;
		this.beanName = beanName;
		this.intfs = intfs;
	}
	
	public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
		if ( method.getDeclaringClass() == ReplaceableProxy.class) {
			return new SerializedClientProxy(rih,beanName,intfs);
		}
		RemoteMethod rmethod = new RemoteMethod(beanName);
		rmethod.setMethod(method);
		rmethod.setArguments(args);
		
		RemoteResult rr = rih.invoke(rmethod);
		
		if (rr.getObject() != null ) {
			return rr.getObject();
		} else {
			throw rr.getRemoteException().getCause();
		}
	}

}
