package org.fmi.ejb;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.rmi.RemoteException;

public class RemoteResult implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6024414036813903322L;
	
	private transient Object object;
	private transient RemoteException remoteException;
	
	private String beanName;
	
	public RemoteResult(String beanName) {
		this.beanName = beanName;
	}
	
	public Object getObject() {
		return object;
	}
	public void setObject(Object object) {
		this.object = object;
	}
	public RemoteException getRemoteException() {
		return remoteException;
	}
	public void setRemoteException(RemoteException remoteException) {
		this.remoteException = remoteException;
	}

	public String getBeanName() {
		return beanName;
	}

	private void writeObject(ObjectOutputStream oos) throws IOException {
		oos.defaultWriteObject();
		oos.writeObject(object);
		oos.writeObject(remoteException);
	}

	private void readObject(ObjectInputStream ois) 
		throws IOException,ClassNotFoundException {
		ois.defaultReadObject();
		if (isServer()) {
			EJBContainer contaner = EJBContainerFactory.getEJBContainer();
			ClassLoader current = Thread.currentThread().getContextClassLoader();
			try {
				Thread.currentThread().setContextClassLoader(
						contaner.getEJB(beanName).getClassLoader());
				object = ois.readObject();
				remoteException = (RemoteException)ois.readObject();
			} finally {
				Thread.currentThread().setContextClassLoader(current);
			}
		} else {
			object = ois.readObject();
			remoteException = (RemoteException)ois.readObject();
		}
	}
	
	private boolean isServer() {
		String server = System.getProperty("org.fmi.ejb.server");
		return server != null && server.equals("true");
	}
	
	
	
}
