package org.fmi.ejb.impl;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Proxy;

import javax.ejb.EJBException;

import org.fmi.ejb.Access;
import org.fmi.ejb.ClientView;
import org.fmi.ejb.ClientViewFactory;
import org.fmi.ejb.EJB;
import org.fmi.ejb.EJBProxyInvocationHandler;
import org.fmi.ejb.InstanceID;

public class DefaultClientViewFactory implements ClientViewFactory {

	protected Access access;
	protected Class intf;
	protected EJBProxyInvocationHandlerFactory handlerFactory;
	protected EJB ejb;
	
	protected Constructor constructor;
	
	DefaultClientViewFactory(Access access,
			EJBProxyInvocationHandlerFactory handlerFactory,
			Class intf,
			EJB ejb) {
		this.access = access;
		this.handlerFactory = handlerFactory;
		this.ejb = ejb;
		this.intf = intf;
		initProxyConstructor();
	}
	
	public Access getAccess() {
		return access;
	}

	public String getInterface() {
		return intf.getName();
	}

	public ClientView newLocalInstance(InstanceID id) {
		EJBProxyInvocationHandler handler = handlerFactory.newInstance(id,this);
		try {
			ClientView proxy = (ClientView)constructor.
				newInstance(new Object[]{handler});
			handler.setClientView(proxy);
			return proxy;
		} catch(Exception ex) {
			throw new EJBException(ex);
		}
	}
	
	protected void initProxyConstructor() {
		try {
			constructor = Proxy.getProxyClass(ejb.getClassLoader(),
					new Class<?>[]{intf, ClientView.class}).
						getConstructor(new Class[]{InvocationHandler.class});
		} catch(Exception ex) {
			throw new EJBException(ex);
		}
	}
	
	public ClientView newInstance(InstanceID id) {
		return newLocalInstance(id);
	}

	public void destroyInstance(ClientView instance) {
	}
	
	public EJB getEJB() {
		return ejb;
	}

	
	
}
