package org.fmi.ejb.impl;

import java.util.HashMap;
import java.util.Map;

import org.fmi.ejb.ClientViewFactory;
import org.fmi.ejb.ClientViewsManager;
import org.fmi.ejb.EJB;

public class DefaultClientViewsManager implements ClientViewsManager {

	private EJB ejb;
	
	private Map<String,ClientViewFactory> factories;
	
	DefaultClientViewsManager(EJB ejb) {
		this.ejb = ejb;
		this.factories = new HashMap<String,ClientViewFactory>();
	}
	
	public void registerFactory(ClientViewFactory factory) {
		factories.put(factory.getInterface(),factory);
	}

	public ClientViewFactory getFactory(String intf) {
		return factories.get(intf);
	}
	
	public EJB getEJB() {
		return ejb;
	}

}
