package org.fmi.ejb.impl;

import java.lang.reflect.Method;
import java.util.List;

import org.fmi.ejb.InvocationChain;

public class DefaultInvocationChain implements InvocationChain {
	
	private Integer[] interceptors;
	private Method businessMethod;
	
	DefaultInvocationChain(List<Integer> interceptors, Method businessMethod) {
		this.interceptors = interceptors.toArray(new Integer[0]); 
		this.businessMethod = businessMethod;
	}
	
	public int size() {
		return interceptors.length;
	}

	public int interceptorAt(int i) {
		return interceptors[i];
	}

	public Method getBusinessMethod() {
		return businessMethod;
	}

}
