package org.fmi.ejb.impl;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

import org.fmi.ejb.InvocationChain;
import org.fmi.ejb.InvocationChains;

public class DefaultInvocationChains implements InvocationChains {

	private Map<Method,InvocationChain> chains;
	private InvocationChain nullChain;
	private Class intf;
	
	DefaultInvocationChains(Class intf) {
		this.intf = intf;
		this.chains = new HashMap<Method,InvocationChain>();
	}
	
	public Class getInterface() {
		return intf;
	}	

	protected void addChain(Method intfMethod, InvocationChain chain) {
		if ( intfMethod == null ) {
			nullChain = chain;
		} else {
			chains.put(intfMethod, chain);
		}
	}
	
	public InvocationChain getChain(Method intfMethod) {
		if ( intfMethod == null ) {
			return nullChain;
		} else {
			return chains.get(intfMethod);
		}
	}

}
