package org.fmi.ejb.impl;

import java.net.URL;
import java.net.URLClassLoader;
import java.util.List;

public class EJBClassLoader extends URLClassLoader {

	private List<String> beanNames;
	
	public EJBClassLoader(URL[] urls, ClassLoader parent) {
		super(urls, parent);
	}
	
	protected void setBeanNames(List<String> beanNames) {
		if (this.beanNames != null) {
			throw new IllegalStateException("beanNames already initialized");
		}
		this.beanNames = beanNames;
	}
	
	protected List<String> getBeanNames() {
		if (this.beanNames == null) {
			throw new IllegalStateException("beanNames not initialized");
		}
		return beanNames.subList(0,beanNames.size());
	}
}
