package org.fmi.ejb.impl;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Proxy;

import javax.ejb.EJBException;

import org.fmi.ejb.Access;
import org.fmi.ejb.ClientView;
import org.fmi.ejb.EJB;
import org.fmi.ejb.InstanceID;
import org.fmi.ejb.ReplaceableProxy;

public class RemoteClientViewFactory extends DefaultClientViewFactory {

	RemoteClientViewFactory(Access access, EJBProxyInvocationHandlerFactory handlerFactory, Class intf, EJB ejb) {
		super(access, handlerFactory, intf, ejb);
	}


	public ClientView newInstance(InstanceID id) {
		ClientView view = newLocalInstance(id);
		return view;
	}

	protected void initProxyConstructor() {
		try {
			constructor = Proxy.getProxyClass(ejb.getClassLoader(),
					new Class<?>[]{intf, ClientView.class, ReplaceableProxy.class }).
						getConstructor(new Class[]{InvocationHandler.class});
		} catch(Exception ex) {
			throw new EJBException(ex);
		}
	}	
}
