package org.fmi.ejb.impl;

import java.lang.reflect.Method;
import java.rmi.RemoteException;

import org.fmi.ejb.ClientView;
import org.fmi.ejb.ClientViewFactory;
import org.fmi.ejb.InstanceID;
import org.fmi.ejb.RemoteInvocationHandler;
import org.fmi.ejb.RemoteMethod;
import org.fmi.ejb.RemoteResult;
import org.fmi.ejb.ReplaceableProxy;
import org.fmi.ejb.SerializedClientProxy;

public class RemoteEJBProxyInvocationHandler 
	extends DefaultEJBProxyInvocationHandler 
	implements RemoteInvocationHandler {

	RemoteEJBProxyInvocationHandler(InstanceID id, ClientViewFactory factory) {
		super(id, factory);
	}
	
	@Override
	public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
		if (method.getDeclaringClass() == ReplaceableProxy.class) {
			return new SerializedClientProxy(this,getFactory().getEJB().getName(),
					new Class[]{clazz,ClientView.class,ReplaceableProxy.class});
		}
		return super.invoke(proxy,method,args);
	}	
	
	public RemoteResult invoke(RemoteMethod method) throws RemoteException {
		RemoteResult rr = new RemoteResult(getFactory().getEJB().getName());
		try {
			Object obj = invoke(getClientView(),method.getMethod(),
					method.getArguments());
			rr.setObject(obj);
		} catch(Throwable t) {
			rr.setRemoteException(new RemoteException("",t));
		}
		return rr;
	}

}
