package org.fmi.ejb.impl;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import javax.ejb.EJBException;

import org.fmi.ejb.ApplicationException;
import org.fmi.ejb.ChainsManager;
import org.fmi.ejb.InstanceID;
import org.fmi.ejb.InvocationChain;

public class RequestEJBInvocationContext extends AbstractEJBInvocationContext {

	RequestEJBInvocationContext(Method intfMethod,ChainsManager manager, InvocationChain chain, InstanceID instanceId) {
		super(intfMethod,manager, chain, instanceId);
	}

	@Override
	protected Object proceedFinal() throws ApplicationException, EJBException {
		if ( getChain().getBusinessMethod() != null ) {
			try {
				return getChain().getBusinessMethod().invoke(
						getEJBInstance().getBeanInstance(),
						getArguments());
			} catch(IllegalAccessException ex) {
				throw new EJBException(ex);
			} catch(InvocationTargetException ex) {
				Throwable t = ex.getCause();
				if (t instanceof Exception) {
					if (t instanceof EJBException ) {
						throw (EJBException)t;
					}
					if (t instanceof RuntimeException) {
						throw new EJBException((Exception)t);
					} 
					for (Class<?> clazz:getChain().getBusinessMethod().getExceptionTypes()) {
						if (clazz.isAssignableFrom(t.getClass())) {
							throw new ApplicationException("",t,false);
						}
					}
					throw new EJBException((Exception)t);
				} else {
					throw new EJBException(new RuntimeException(t));
				}
			}
		} else {
			return null;
		}
	}

}
